=== mscore/demos/CMakeLists.txt ===
#=============================================================================
#  MusE
#  Linux Music Editor
#  $Id:$
#
#  Copyright (C) 2002-2008 by Werner Schweer and others
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#=============================================================================

install(FILES
      sarabande.xml
      adeste.mscx
      bach-bc2.mscx
      inv1.mscx
      inv4.mscx
      inv6.mscx
      inv10.mscx
      inv13.mscx
      praeludium1.mscx
      prelude.mscx
      promenade.mscx
      scales.mscx
      sonata16.mscx
      italian-1.mscz
      golliwogg.mscx
      Estudio-No1-Tarrega.mscx
      PlanxtyCarolan.mscx
      wtc1fuga5.mscz
      schnee.mscz
      sarabande-gfh.mscz
      All_Dudes.mscz
      Triumph.mscz
      Reunion.mscz
      DESTINATION ${Mscore_SHARE_NAME}${Mscore_INSTALL_NAME}demos
      )
