=== debian/changelog ===
musescore (1.3+dfsg-1) unstable; urgency=low

  * New upstream release
    + see <http://musescore.org/en/musescore-1.3>
    + important bug fixes (Closes: #591908; LP: #1010457)
  * debian/control:
    + update long description for musescore-common
    + depend on mawk not gawk (Closes: #667845)
    + depend on individual libqtscript4 packages rather than the metapackage
      libqtscript4-qtbindings, since -opengl will not install on GNU/Hurd, thereby
      making musescore uninstallable
  * debian/patches:
    + drop 20-fix-dso-linking.patch
    + add 25-build-hurd.patch: add rules to CMakeLists to build on GNU or kFreeBSD

 -- Toby Smithe <tsmithe@ubuntu.com>  Wed, 19 Feb 2014 23:04:53 +0000

musescore (1.2+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches
    - add adjust-newer-freetype-header-location.patch (Closes: #733363)

 -- Hideki Yamane <henrich@debian.org>  Wed, 05 Feb 2014 21:19:03 +0900
